﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.Patterns.Core
{
    public class PersonService1
    {
        public void Save(Person saveThis)
        {
            if (saveThis == null)
            {
                throw new InvalidOperationException("Cannot save a null person.");
            }
            else
            {
                if (String.IsNullOrWhiteSpace(saveThis.FirstName) == false &&
                    String.IsNullOrWhiteSpace(saveThis.LastName) == false &&
                    String.IsNullOrWhiteSpace(saveThis.EmailAddress) == false)
                {
                    throw new InvalidOperationException("Person has invalid data.");
                }

                if (saveThis.Id == 0)
                {
                    bool isEmailAddressOk = false;

                    using (SqlConnection conn = new SqlConnection(GetConnectionString()))
                    {
                        using (SqlCommand cmd = new SqlCommand("Person_IsEmailAddressInUse", conn))
                        {
                            AddParameterToCommand(cmd, saveThis.EmailAddress);

                            var result = (bool)cmd.ExecuteScalar();

                            if (result == true)
                            {
                                throw new InvalidOperationException("Email address is already in use.");
                            }
                            else
                            {
                                isEmailAddressOk = true;
                            }
                        }
                    }

                    if (isEmailAddressOk == true)
                    {
                        SaveToDatabase(saveThis);
                    }
                }
                else
                {
                    try
                    {
                        SaveToDatabase(saveThis);
                    }
                    catch (SqlServerOutOfDiskSpaceException ex)
                    {
                        new Logger().WriteToLog(ex.ToString());

                        throw;
                    }
                }
            }
        }

        private void SaveToDatabase(Person saveThis)
        {
            throw new NotImplementedException();
        }

        private void AddParameterToCommand(SqlCommand cmd, string emailAddress)
        {
            // do some stuff
        }
        private string GetConnectionString()
        {
            return null;
        }
    }
}