using Benday.SampleApp2.Web;
using Benday.SampleApp2.Web.Controllers;
using Benday.SampleApp2.Web.Core;
using Benday.SampleApp2.Web.Models;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace Benday.SampleApp2.Tests
{
    [TestClass]
    public class SearchControllerFixture
    {
        private SearchController _SystemUnderTest;
        public SearchController SystemUnderTest
        {
            get
            {
                if (_SystemUnderTest == null)
                {
                    _SystemUnderTest = new SearchController();
                }

                return _SystemUnderTest;
            }
        }

        [TestMethod]
        public void GetListReturnsAll()
        {
            var result = SystemUnderTest.Get();

            Assert.IsNotNull(result);
            Assert.IsNotNull(result.Results);
            Assert.AreEqual<int>(44, result.Results.Count, "Result count was wrong.");
        }


        [TestMethod]
        public void GetByLastName()
        {
            string firstName = String.Empty;
            string lastName = "adams";

            var result = SystemUnderTest.Get(firstName, lastName);

            Assert.IsNotNull(result);
            Assert.IsNotNull(result.Results);
            Assert.AreEqual<int>(2, result.Results.Count, "Result count was wrong.");
        }

        [TestMethod]
        public void GetByFirstName()
        {
            string firstName = "zach";
            string lastName = String.Empty;

            var result = SystemUnderTest.Get(firstName, lastName);

            Assert.IsNotNull(result);
            Assert.IsNotNull(result.Results);
            Assert.AreEqual<int>(1, result.Results.Count, "Result count was wrong.");
        }

        [TestMethod]
        public void GetByFirstAndLastName()
        {
            string firstName = "ben";
            string lastName = "harr";

            var result = SystemUnderTest.Get(firstName, lastName);

            Assert.IsNotNull(result);
            Assert.IsNotNull(result.Results);
            Assert.AreEqual<int>(1, result.Results.Count, "Result count was wrong.");
        }

        [TestMethod]
        public void GetByFirstAndLastNameGarbageNames()
        {
            string firstName = Guid.NewGuid().ToString();
            string lastName = Guid.NewGuid().ToString();

            var result = SystemUnderTest.Get(firstName, lastName);

            Assert.IsNotNull(result);
            Assert.IsNotNull(result.Results);
            Assert.AreEqual<int>(0, result.Results.Count, "Result count was wrong.");
        }
    }
}
