using Benday.SampleApp2.Web.Core;
using Benday.SampleApp2.Web.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Mvc;

namespace Benday.SampleApp2.Web.Controllers
{
    public class PresidentController : Controller
    {
        public ActionResult Index()
        {
            var model = new PresidentSearch();

            InitializeToBlank(model);

            return View(model);
        }
        private void InitializeToBlank(PresidentSearch model)
        {
            model.SearchByFirstName = String.Empty;
            model.SearchByLastName = String.Empty;

            if (model.Results == null)
            {
                model.Results = new List<President>();
            }

            model.Results.Clear();
        }

        public ActionResult Search(string searchByFirstName, string searchByLastName)
        {
            var model = new PresidentSearch();

            InitializeToBlank(model);

            model.SearchByFirstName = searchByFirstName;
            model.SearchByLastName = searchByLastName;

            model.Results = new PresidentManager().GetList(searchByFirstName, searchByLastName);

            return View("Index", model);
        }
    }
}
