﻿using Benday.SampleApp2.Web.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Xml.Linq;

namespace Benday.SampleApp2.Web.Core
{
    public class PresidentManager
    {
        public List<President> GetList()
        {
            List<President> returnValues = new List<President>();

            President toValue;

            var doc = XDocument.Parse(WebDataResource.UsPresidents);

            var fromValues = doc.Root.ElementsByLocalName("president");

            var adapter = new PresidentAdapter();

            foreach (var fromValue in fromValues)
            {
                toValue = new President();

                adapter.Adapt(fromValue, toValue);

                returnValues.Add(toValue);
            }

            return returnValues;
        }

        public List<President> GetList(string first, string last)
        {
            List<President> allValues = GetList();
            
            if (String.IsNullOrWhiteSpace(first) == true && 
                String.IsNullOrWhiteSpace(last) == true)
            {
                return allValues;
            }
            else
            {
                List<President> returnValues = null;

                if (String.IsNullOrWhiteSpace(first) == false &&
                    String.IsNullOrWhiteSpace(last) == false)
                {
                    returnValues = SearchByFirstAndLastName(first, last, allValues);
                }
                else if (String.IsNullOrWhiteSpace(first) == false)
                {
                    returnValues = SearchByFirstName(first, allValues);   
                }
                else
                {
                    returnValues = SearchByLastName(last, allValues);
                }

                return returnValues;
            }
        }
        private List<President> SearchByFirstAndLastName(string first, 
            string last, 
            List<President> allValues)
        {
            first = first.ToLower();
            last = last.ToLower();

            var returnValues = (from temp in allValues
                                where temp.LastName.ToLower().Contains(last) && 
                                temp.FirstName.ToLower().Contains(first)
                            select temp).ToList();

            return returnValues;
        }

        private List<President> SearchByFirstName(string first,
            List<President> allValues)
        {
            first = first.ToLower();

            var returnValues = (from temp in allValues
                                where temp.FirstName.ToLower().Contains(first)
                                select temp).ToList();

            return returnValues;
        }

        private List<President> SearchByLastName(string last,
            List<President> allValues)
        {
            last = last.ToLower();

            var returnValues = (from temp in allValues
                                where temp.LastName.ToLower().Contains(last)
                                select temp).ToList();

            return returnValues;
        }
    }
}