﻿// 'use strict';

describe('theApp', function () {
    var scope;
    var controller;
    beforeEach(function () {
        module('app.controllers');
    });

    describe('CalculatorCtrl', function () {
        beforeEach(inject(function ($rootScope, $controller) {
            scope = $rootScope.$new();
            controller = $controller('CalculatorCtrl', {
                '$scope': scope
            });
        }));

        it('should start with all values as 0', function() {
    
            //just assert. $scope was set up in beforeEach() (above)
            expect(scope.value1).toEqual(0);
            expect(scope.value2).toEqual(0);
            expect(scope.result).toEqual(0);
        });

        it('adds 1 plus 2 and gets 3 as a result', function() {
    
            scope.value1 = 1;
            scope.value2 = 2;
            scope.add();

            //just assert. $scope was set up in beforeEach() (above)
            expect(scope.value1).toEqual(1);
            expect(scope.value2).toEqual(2);
            expect(scope.result).toEqual(3);
        });

        it('sets all values back to 0 when reset is called', function () {

            scope.value1 = 1;
            scope.value2 = 2;
            scope.result = 3;
            scope.reset();

            //just assert. $scope was set up in beforeEach() (above)
            expect(scope.value1).toEqual(0);
            expect(scope.value2).toEqual(0);
            expect(scope.result).toEqual(0);
        });
    });
});