﻿
angular.module('app.controllers').controller(
    'PresidentCtrl', ['$scope', 'presidentRepository', function ($scope, presidentRepository) {
        $scope.repositoryInstance = presidentRepository;

        $scope.theTime = $scope.repositoryInstance.getCurrentTime();

        $scope.firstName = '';
        $scope.lastName = '';

        $scope.items = [];

        $scope.recordCount = 0;

        $scope.reset = function () {
            $scope.firstName = '';
            $scope.lastName = '';
            $scope.items = [];
            $scope.recordCount = 0;
        }

        $scope.search = function () {
            $scope.repositoryInstance.runSearch(
                $scope.firstName, $scope.lastName, function (data) {

                    if (typeof data === 'undefined') {
                        $scope.recordCount = -1;

                        $scope.items = [];
                    }
                    else {
                        $scope.recordCount = data.Results.length;

                        $scope.items = data.Results;
                    };
                });
        }
    }]);

angular.module('app.controllers').factory('presidentRepository', ['$http', function ($http) {
    return {
        getCurrentTime: function () {
            return "i'm not telling you.";
        },

        runSearch: function (first, last, callback) {
            var url = 'api/search?first=' + first + '&last=' + last;

            $http.get(url).success(callback);
        }
    }
}]);